#include "Creature.h"
#include <string>
#include "AI_Behaviors.h"
#include "Sprite_Animation.h"
#include <stdlib.h>     /* srand, rand */
#include <time.h>       /* time */
#pragma once

class State;

class AIMonster: public Creature
{
private:
	//bool seek;
	//bool idle;
	//bool attack;
	//bool flee;
	//bool wander;

public:
	State *Current_State;
	State *Prev_State;
	Ogre::Real mDistance;                  // The distance the object has left to travel
    Ogre::Vector3 mDirection;              // The direction the object is moving
    Ogre::Vector3 mDestination;            // The destination the object is moving towards
	Ogre::Vector3 prePosition;			   // previous position
	Ogre::AxisAlignedBox box;			   // collision detection box
	Ogre::Vector3 Player_Location;
	AI_Behaviors *AIB;
	
	string ATTACK;
	string IDLE;
	string WALK;

	bool attackAN;
	bool idleAN;
	bool walkAN;

//*****************************************************************************
	AIMonster();

	~AIMonster();

//*****************************************************************************
//access functions
//*****************************************************************************
	void set_moveSpeed(Ogre::Real change);

	void set_Scale(Ogre::Real change);

	void set_Name(string Name);

	void setDestination(Ogre::Vector3 GoingTo);

	void Find_Player_Location(Ogre::Vector3 location);

	void Set_Animation_Names(string attack, string walk, string idle);


//*****************************************************************************


	void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName);

	void rotateRobotToDirection(void);

	void update(const Ogre::FrameEvent &evt);

	void translate(const Ogre::FrameEvent& evt);

	void updateRealStats();

	void reset();

};//end of class



class AIMonster_Collection
{
public:
	static const int MAXMONSTER = 4;
	Ogre::Vector3 GroupLocation;
	AIMonster monsters[MAXMONSTER];

	AIMonster_Collection();

	void Group_Location(Ogre::Vector3 location);

	void create(Ogre::SceneManager* sentSceneMgr);

	void update(const Ogre::FrameEvent& evt);
};