// Title       : Armour.h
// Date        : 21/05/13
// Description : The class for the player's armour

#include "Item.h"

#pragma once

// Enum for the type of armour
enum ArmourType {Head, Body, Arms, Legs, ArmourTypeNone};

class Armour: public Item
{
private:
  int defenceStt;         // The defence stat for the piece of armour
  ArmourType armourType;  // The type of armour

public:
  // Variables
  Ogre::Vector3 weaponVectorFromRightHand; // Vector for the weapon from the
                                           // right hand

  // Constrcutors and Destructors
  Armour(); // Constructor

  // Getters and Setters
  void setArmourType(ArmourType value);    // Sets armour type
  ArmourType getArmourType();              // Gets armour type

  void setDenfenceStt(int value);          // Sets armour defence
  int getDefenceStt();                     // Gets armour defence

};