// Title       : Arrow.h
// Date        : 21/05/13
// Description : The class for an arrow

// Includes
#include "Weapon.h"

#pragma once

class Arrow: public Weapon
{
private:
  static const int MAXFLIGHTTIME = 3; // The maximum flight time
  Ogre::Real shootDistance;           // Distance can shoot

public:
  // Variables
  double flightTimer;                 // Timer for how long arrow flies

  // Constructors and Destructors
  Arrow();  // Constructor
  ~Arrow(); // Destructor

  // Getters and Setters
  void setPosition(Ogre::Vector3 thePosition); // Sets arrow position
  void setActive(bool value);                  // Sets arrow active

  // Create and Reset
  void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName);
  void reset();

  // Update
  void update(const Ogre::FrameEvent& evt);    // Updates the arrow
};

