// Title       : ArrowColelction.cpp
// Date        : 21/05/13
// Description : The implementation of the class for an arrow collection

#include "ArrowCollection.h"

// ****************************************************************************
// Constructors and Destructors

ArrowCollection::ArrowCollection()
{ // Constrcutor

  // Set the delay between shots
  delayBetweenShots = DELAYBETWEENSHOTS;
}

// ****************************************************************************
// Create and Reset

void ArrowCollection::create(Ogre::SceneManager* sentSceneMgr)
{ // Creates the array of arrows
  arrows[0].create(sentSceneMgr, "Arrow1");
  arrows[1].create(sentSceneMgr, "Arrow2");
  arrows[2].create(sentSceneMgr, "Arrow3");
  arrows[3].create(sentSceneMgr, "Arrow4");
  arrows[4].create(sentSceneMgr, "Arrow5");
  arrows[5].create(sentSceneMgr, "Arrow6");
  arrows[6].create(sentSceneMgr, "Arrow7");
  arrows[7].create(sentSceneMgr, "Arrow8");
}

// ****************************************************************************
// Update
void ArrowCollection::update(const Ogre::FrameEvent& evt)
{ // Updates the array of arrows
  delayBetweenShots = delayBetweenShots - 1*evt.timeSinceLastEvent;

  for(int i =0;i<MAXARROWS;i++)
  {
    arrows[i].update(evt);
  }
}

// ****************************************************************************
// Object Specific

void ArrowCollection::shoot(Ogre::SceneNode* scenenode, Ogre::Vector3 tranlationFromNode)
{
  if(delayBetweenShots<0)
  {
    for(int i =0;i<MAXARROWS;i++)
	{
	  if(arrows[i].active==false)
	  {
	    arrows[i].reset();
		arrows[i].active = true;
		arrows[i].entityNode->setOrientation(scenenode->getOrientation());
		arrows[i].entityNode->setPosition(scenenode->getPosition());
		arrows[i].entityNode->translate(tranlationFromNode, Ogre::Node::TS_LOCAL);
		delayBetweenShots = DELAYBETWEENSHOTS;
        break;
	  } // End if
	} // End for
  } // End if
} // End shoot