// Title       : ArrowColelction.h
// Date        : 21/05/13
// Description : The class for an arrow collection

#include "Arrow.h"

#pragma once

class ArrowCollection
{
private:
  static const int MAXARROWS = 8;          // The maximum arrows a player can have
  static const int DELAYBETWEENSHOTS = 1;  // Delay between shots
public:
  // Variables
  Arrow arrows[MAXARROWS];               // Array of arrows
  double delayBetweenShots;              // Delay between shots

  // Constructors and Destructors
  ArrowCollection();

  // Create and Reset
  void create(Ogre::SceneManager* sentSceneMgr);

  // Update
  void update(const Ogre::FrameEvent& evt);

  // Shoot
  void shoot(Ogre::SceneNode* scenenode, Ogre::Vector3 tranlationFromNode);
};