#include <OgreConfigFile.h>
#include <map>

class ConfigLoader
{
private:
	

	//protection from singletons, prevent copy construction
	//HALConfig(const ConfigLoader &); 
	//protection for singletons, prevent assignemnt
	//HALConfig& operator=(const ConfigLoader &);

	//the configuration file
	Ogre::ConfigFile configurationFile;
	//where the configuration data is stored
	std::map<std::string, std::string> configurations;

public:
	ConfigLoader(); //constructor
	~ConfigLoader(); //destructor

	static ConfigLoader getInstance();

	//getters and setters to be used by class clients to get configurations
	bool getKeyExists(std::string key);
	bool getValueAsBool(std::string key);
	int getValueAsInt(std::string key);
	std::string getValueAsString(std::string key);
	Ogre::Real getValueAsReal(std::string key);
	Ogre::Vector3 getValueAsVector3(std::string key);
	Ogre::ColourValue getValueAsColourValue(std::string key);
};//end ConfigLoader

