#include "Creature.h"


Creature::Creature()
{
	rotateValue = 0.13;
	moveValue = 250;

	level		       = STARTINGLEVEL;
	baseHealthStt  = STARTINGHEALTH;
	baseAttackStt  = STARTINGATTACK;
	baseDefenceStt = STARTINGDEFENCE;
	baseDextStt    = STARTINGDEXT;
	baseSpeedStt   = STARTINGSPEED;

	realHealthStt	 = baseHealthStt;
	realAttackStt  = baseAttackStt;
	realDefenceStt = baseDefenceStt;
	realDextStt	   = baseDextStt;
	realSpeedStt	 = baseSpeedStt;

	alive = false;
}//end of constructor

const Ogre::Vector3& Creature::getPosition(void) 
{
	return entityNode->getPosition();
}// end of getPosition


void Creature::setupStandardBaseStats(int requestedLevel)
{
	level = requestedLevel;
	baseHealthStt = STARTINGHEALTH + (HEALTHLEVELUP * requestedLevel);
	baseAttackStt = STARTINGATTACK + (ATTACKLEVELUP * requestedLevel);
	baseDefenceStt = STARTINGDEFENCE + (DEFENCELEVELUP * requestedLevel);
	baseDextStt = STARTINGDEXT + (DEXTLEVELUP * requestedLevel);
	baseSpeedStt = STARTINGSPEED + (SPEEDLEVELUP * requestedLevel);

	realHealthStt = baseHealthStt;
	realAttackStt = baseAttackStt;
	realDefenceStt = baseDefenceStt;
	realDextStt = baseDextStt;
	realSpeedStt = baseSpeedStt;
}//end of setupStandardBaseStats

void Creature::Animation(const Ogre::FrameEvent &evt, string aName)
{
	// Set idle animation
    mAnimationState = entity->getAnimationState(aName);
    mAnimationState->setLoop(true);
    mAnimationState->setEnabled(true);

	mAnimationState->addTime(evt.timeSinceLastFrame);
}//end of idle()