#include "Object.h"

#pragma once

// Abstract
class Creature: public Object
{
private:

protected:

public:
	Ogre::AnimationState *mAnimationState;  //animation state

		//starting atttributes to be loaded in from file
	static const int STARTINGLEVEL = 1;
	static const int STARTINGHEALTH = 20;
	static const int STARTINGATTACK = 5;
	static const int STARTINGDEFENCE = 4;
	static const int STARTINGDEXT = 3;
	static const int STARTINGSPEED = 3;

		//level up modifiers
	static const int HEALTHLEVELUP = 4;
	static const int ATTACKLEVELUP = 2;
	static const int DEFENCELEVELUP = 2;
	static const int DEXTLEVELUP = 1;
	static const int SPEEDLEVELUP = 2;

	// stats of the creature w/o buffs+debuffs from armour, skills etc.
	int baseHealthStt;
	int baseAttackStt;
	int baseDefenceStt;
	int baseDextStt;
	int baseSpeedStt;

	// stats of the creature with buffs+debuffs from armour, skills etc.
	// used for damage calcualtion.
	int realHealthStt;
	int realAttackStt;
	int realDefenceStt;
	int realDextStt;
	int realSpeedStt;

	Ogre::Real rotateValue;          // The rotate constant
	Ogre::Real moveValue;            // The movement constant

	int level;
	bool alive;



	//Ogre::Real direction;


	Creature();
	
	const Ogre::Vector3 getDirection(void) 
  {
		return Ogre::Vector3(Ogre::Math::Cos(entityNode->getPosition().x),0,Ogre::Math::Sin(entityNode->getPosition().z));
  }

	const Ogre::Vector3& getPosition(void);


	void setupStandardBaseStats(int requestedLevel);

	// children class must override this subprogram.
	virtual void updateRealStats() = 0;

	void Animation(const Ogre::FrameEvent &evt, string aName);

	void setBaseStatsBasedOnLevel(int level)
	{
		baseHealthStt = STARTINGHEALTH + HEALTHLEVELUP * level;
		baseAttackStt = STARTINGATTACK + ATTACKLEVELUP * level;
		baseDefenceStt = STARTINGDEFENCE + DEFENCELEVELUP * level;
		baseDextStt = STARTINGDEXT + DEXTLEVELUP * level;
		baseSpeedStt = STARTINGSPEED + SPEEDLEVELUP * level;
	}

	void setRealStatsSameAsBaseStats()
	{
		realHealthStt = baseHealthStt;
		realAttackStt = baseAttackStt;
		realDefenceStt = baseDefenceStt;
		realDextStt = baseDextStt;
		realSpeedStt = baseSpeedStt;
	}
};