#include "Object.h"

string Object::getCollidedObject()
{
	return collidedObject;
}

void Object::removeColliedOBject()
{
	collidedObject = "Unkown";
}

Object::Object()
{
	//direction = Ogre::Vector3::ZERO;
	active = true;
	entity = NULL;
	entityNode = NULL;
	sceneMgr = NULL;
	raySceneQuery = NULL;
	collidedObject = "Unkown";
	prePosition = Ogre::Vector3(0,0,0);
	displacementFromGround = 0;

	objectType = ObjectNone;
}//end of constructor

// collision detection
bool Object::isCollision(const Ogre::Vector3& position, const Ogre::Vector3& direction) 
{

	Ogre::Ray ray(position, Ogre::Vector3::NEGATIVE_UNIT_Y);
  raySceneQuery->setRay(ray);
  Ogre::RaySceneQueryResult &result = raySceneQuery->execute();
  Ogre::RaySceneQueryResult::iterator itr;

  for (itr = result.begin(); itr != result.end(); itr++) 
	{

		std::ostringstream buffDistance;
    buffDistance<<itr->distance;
		std::ostringstream buffTotal;
		buffTotal<<result.size();

    if (itr->movable->getName().compare(name)!=0 && itr->distance<length/2) 
		{
			Ogre::LogManager::getSingleton().logMessage("\nCollision TRUE with "+itr->movable->getName()+
				" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
					
			collidedObject = itr->movable->getName().compare(name);
      return true;
    }
		else
		{
			Ogre::LogManager::getSingleton().logMessage("\nCollision FALSE with"+itr->movable->getName()+
				" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
		}
  }

  return false;
}


// collision detection
bool Object::isCollision(const Ogre::Vector3& position, const Ogre::Vector3& direction, 
	Ogre::String nameOfObject) 
{

	Ogre::Ray ray(position, direction);//Ogre::Vector3::NEGATIVE_UNIT_Y);
  raySceneQuery->setRay(ray);
  Ogre::RaySceneQueryResult &result = raySceneQuery->execute();
  Ogre::RaySceneQueryResult::iterator itr;

  for (itr = result.begin(); itr != result.end(); itr++) 
	{

		std::ostringstream buffDistance;
		buffDistance<<itr->distance;
		std::ostringstream buffTotal;
		buffTotal<<result.size();

    if (itr->movable->getName().compare(nameOfObject)==0 && itr->distance<length/2) 
		{
			Ogre::LogManager::getSingleton().logMessage("\nCollision TRUE with "+itr->movable->getName()+
				" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
					
			collidedObject = itr->movable->getName().compare(name);
      return true;
    }
		else
		{
			Ogre::LogManager::getSingleton().logMessage("\nCollision FALSE with"+itr->movable->getName()+
				" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
		}
  }

  return false;
}


// collision detection
bool Object::isCollisionMonster(const Ogre::Vector3& position, const Ogre::Vector3& direction) 
{

	Ogre::Ray ray(position, /*direction);*/Ogre::Vector3::NEGATIVE_UNIT_Y);
  raySceneQuery->setRay(ray);
  Ogre::RaySceneQueryResult &result = raySceneQuery->execute();
  Ogre::RaySceneQueryResult::iterator itr;

	for(int i = 0; i< MONSTERLISTSIZE; i++)
	{
		for (itr = result.begin(); itr != result.end(); itr++) 
		{

			std::ostringstream buffDistance;
      buffDistance<<itr->distance;
			std::ostringstream buffTotal;
			buffTotal<<result.size();

      if (itr->movable->getName().compare(MONSTERLIST[i])==0 && itr->distance<length/2) 
			{
				Ogre::LogManager::getSingleton().logMessage("\nCollision TRUE with "+itr->movable->getName()+
					" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
					
				collidedObject = itr->movable->getName();
        return true;
      }
			else
			{
				Ogre::LogManager::getSingleton().logMessage("\nCollision FALSE with"+itr->movable->getName()+
					" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
			}
    }
	}


  return false;
}



// collision detection, for a list of object.
bool Object::isCollision(const Ogre::Vector3& position, Object* objects[], int numberOfObjects,
		const Ogre::Vector3& direction) 
{

	Ogre::Ray ray(position, direction);//Ogre::Vector3::NEGATIVE_UNIT_Y);
  raySceneQuery->setRay(ray);
  Ogre::RaySceneQueryResult &result = raySceneQuery->execute();
  Ogre::RaySceneQueryResult::iterator itr;

	for(int i = 0; i< numberOfObjects; i++)
	{
		for (itr = result.begin(); itr != result.end(); itr++) 
		{

			std::ostringstream buffDistance;
      buffDistance<<itr->distance;
			std::ostringstream buffTotal;
			buffTotal<<result.size();

			if (itr->movable->getName().compare(objects[i]->name)==0 && itr->distance<length/2) 
			{
				Ogre::LogManager::getSingleton().logMessage("\nCollision TRUE with "+itr->movable->getName()+
					" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
					
				collidedObject = itr->movable->getName();
        return true;
      }
			else
			{
				Ogre::LogManager::getSingleton().logMessage("\nCollision FALSE with"+itr->movable->getName()+
					" at distance "+buffDistance.str()+". Total movable Object: "+buffTotal.str()+" |"+name+"|\n");
			}
    }
	}


  return false;
}