#include "Player.h"

void Player::pickUp(Object* items[], int numberOfItems)
{
	if(this->isCollision(bodyArmour->entityNode->getPosition(), 
		items, numberOfItems, playerPosition))
	{
		for(int i = 0; i < numberOfItems; i++)
		{
			if(items[i]->name==getCollidedObject())
			{
				if(items[i]->objectType==ObjectArmourType)
				  equipArmour((Armour*)items[i]);
				else if(items[i]->objectType==ObjectWeaponType)
				  equipWeapon((Weapon*)items[i]);
			}
		}
	}

}

void Player::equipWeapon(Weapon* weapon)
{
	if(weaponEquipped==true)
	{
		equippedWeapon->entityNode->setPosition(playerPosition);
		equippedWeapon = NULL;
	}

	equippedWeapon = weapon;
	equippedWeapon->entity->setQueryFlags(false);
	weaponEquipped = true;

	updateRealStats();
}

void Player::unequipWeapon()
{
	if(weaponEquipped==true)
	{
		equippedWeapon->entity->setQueryFlags(true);
		equippedWeapon->entityNode->setPosition(playerPosition+Ogre::Vector3(0,50,70));
		equippedWeapon = NULL;
		weaponEquipped = false;
	}
}

void Player::unequipArmour(int parts) // 0 = head, 1 = body, 2 = arms, 3 = legs
{
	if(headEquipped==true && parts == 0)
	{
		headArmour->entity->setQueryFlags(true);
		headArmour->entityNode->setPosition(playerPosition+Ogre::Vector3(0,100,100));
		headArmour = NULL;
		headEquipped = false;
		headArmour = defaultHeadArmour;
		defaultHeadArmour->entity->setVisible(true);
		
	}
	else if(bodyEquipped==true && parts == 1)
	{
		bodyArmour->entity->setQueryFlags(true);
		bodyArmour->entityNode->setPosition(playerPosition+Ogre::Vector3(0,100,100));
		bodyArmour = NULL;
		bodyEquipped = false;
		bodyArmour = defaultBodyArmour;
		defaultBodyArmour->entity->setVisible(true);
	}
	else if(armsEquipped==true && parts == 2)
	{
		armsArmour->entity->setQueryFlags(true);
		armsArmour->entityNode->setPosition(playerPosition+Ogre::Vector3(0,100,100));
		armsArmour = NULL;
		armsEquipped = false;
		armsArmour = defaultArmsArmour;
		defaultArmsArmour->entity->setVisible(true);
	}
	else if(legsEquipped==true && parts == 3)
	{
		legsArmour->entity->setQueryFlags(true);
		legsArmour->entityNode->setPosition(playerPosition+Ogre::Vector3(0,100,100));
		legsArmour = NULL;
		legsEquipped = false;
		legsArmour = defaultLegsArmour;
		defaultLegsArmour->entity->setVisible(true);
	}
}


void Player::equipArmour(Armour* armour)
{


	if(armour->getArmourType()==Head)
	{
		if(headEquipped==true)
		{
			/*headArmour->entityNode->setPosition(playerPosition);
			headArmour = NULL;*/
			unequipArmour(0);
		}
		else
		{
			//defaultHeadArmour->entity->setVisible(false);
		}

		
		headEquipped = true;
		headArmour = armour;
		headArmour->entityNode->setPosition(playerPosition);
		headArmour->entityNode->setOrientation(playerOrientation);
		headArmour->entity->setQueryFlags(false);
	}
	else if(armour->getArmourType()==Body)
	{
		if(bodyEquipped==true)
		{
			//bodyArmour->entityNode->setPosition(playerPosition);
			//bodyArmour = NULL;
			unequipArmour(1);
		}
		else
		{
			//defaultBodyArmour->entity->setVisible(false);
		}
		bodyEquipped = true;
		bodyArmour = armour;
		bodyArmour->entityNode->setPosition(playerPosition);
		bodyArmour->entityNode->setOrientation(playerOrientation);
		bodyArmour->entity->setQueryFlags(false);
	}
	else if(armour->getArmourType()==Arms)
	{
		if(armsEquipped==true)
		{
			//armsArmour->entityNode->setPosition(playerPosition);
			//armsArmour = NULL;
			unequipArmour(2);
		}
		else
		{
			//defaultArmsArmour->entity->setVisible(false);
		}
		armsEquipped = true;
		armsArmour = armour;
		armsArmour->entityNode->setPosition(armsPosition);
		armsArmour->entityNode->setOrientation(armsOrientation);
		armsArmour->entity->setQueryFlags(false);
	}
	else if(armour->getArmourType()==Legs)
	{
		if(legsEquipped==true)
		{
			legsArmour->entityNode->setPosition(playerPosition);
			legsArmour = NULL;
			unequipArmour(3);
		}
		else
		{
			//defaultLegsArmour->entity->setVisible(false);
		}
		legsEquipped = true;
		legsArmour = armour;
		legsArmour->entityNode->setPosition(playerPosition);
		legsArmour->entityNode->setOrientation(playerOrientation);
		legsArmour->entity->setQueryFlags(false);
  }
		
	updateRealStats();
}

void Player::updateRightHand(const Ogre::FrameEvent& evt)
{

	armsArmour->entityNode->setPosition(playerPosition+armsVectorFrombody);
	armsArmour->entityNode->setOrientation(playerOrientation);

	if(this->equippedWeapon)
	{
		equippedWeapon->entityNode->setOrientation(playerOrientation);
	

		equippedWeapon->entityNode->setPosition(playerPosition);
		equippedWeapon->entityNode->translate(rightHandVectorFromArm,Ogre::Node::TS_LOCAL);

		

		if(equippedWeapon->getWeaponType()==Bow)
		{
			rightHandPitchTotal+=rightHandPitchValue* evt.timeSinceLastFrame;

			armsArmour->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), Ogre::Node::TS_LOCAL);
			equippedWeapon->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), Ogre::Node::TS_LOCAL);

			if(isAttack==true)
			{
				arrowCollection.shoot(equippedWeapon->entityNode, armsArmour->weaponVectorFromRightHand);
				isAttack = false;
			}

			arrowCollection.update(evt);
		}
		else if(equippedWeapon->getWeaponType()==Sword)
		{
			if(isAttack==true)
			{
				isAttacking=true;
				isAttack=false;
				rightHandPitchTotal = 0;
			}

			if(isAttacking==true)
			{
				meleeAttackTime = meleeAttackTime- 1* evt.timeSinceLastFrame;
				if(meleeAttackTime>0.4)
				{
					rightHandPitchTotal+=400* evt.timeSinceLastFrame;

					armsArmour->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), 
						Ogre::Node::TS_LOCAL);
	
					equippedWeapon->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), 
						Ogre::Node::TS_LOCAL);

				}
				else
				{
					rightHandPitchTotal-=400* evt.timeSinceLastFrame;

					armsArmour->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), 
						Ogre::Node::TS_LOCAL);
	
					equippedWeapon->entityNode->pitch(Ogre::Degree(rightHandPitchTotal), 
						Ogre::Node::TS_LOCAL);

				}

				if(meleeAttackTime<0)
				{
					meleeAttackTime = 0.8;
					isAttacking = false;
				}

			}
		}
		equippedWeapon->entityNode->translate(armsArmour->weaponVectorFromRightHand,
			Ogre::Node::TS_LOCAL);
	}
	
}

Player::Player():camera(0)
{


	playerPosition = Ogre::Vector3::ZERO;
	armsPosition = Ogre::Vector3::ZERO;

	playerOrientation = Ogre::Quaternion::ZERO;
	armsOrientation = Ogre::Quaternion::ZERO;

	equippedWeapon = NULL;

	weaponEquipped = false;
	headEquipped = false;
	bodyEquipped = false;
	armsEquipped = false;
	legsEquipped = false;
	meleeAttackTime = 0.8;
	jumpTime = 0.8;

	camNode = NULL;
	rightHandPitchValue = 0;
	rightHandPitchTotal = 0;

	isAttack = false;
	isAttacking = false;
	isJumping = false;

	// set the rotation and move speed
	rotateValue = 0.13;
	moveValue = 250;

	numShineyRock = 0;
	currentWeightStt = 0;
	maximumWeightStt = 20;

	alive = true;
	name = "";
	scale = 10.0;
	accelerateValue = Ogre::Vector3::ZERO;
	this->level = 1;

	cameraVectorFromEntity = Ogre::Vector3(0,150,200);

	rightHandVectorFromArm = Ogre::Vector3(40,175,0);
	armsVectorFrombody = Ogre::Vector3(0,175,0);
}

Player::Player(int requestedLevel):camera(0)
{
	camNode = NULL;


	// set the rotation and move speed
	rotateValue = 0.13;
	moveValue = 250;

	//Starting weight and currency values
	numShineyRock = 0;
	currentWeightStt = 0;
	maximumWeightStt = 20;

	//Read in player stats from file
	//name = ConfigLoader::getInstance().getValueAsString("Player/NAME");
	//startingLevel = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGLEVEL");
	//startingHealth = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGHEALTH");
	//startingAttack = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGATTACK");
	//startingDefence = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGDEFENCE");
	//startingDext = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGDEXT");
	//startingSpeed = ConfigLoader.getInstance().getValueAsInt("Player/STARTINGSPEED");
	//
	setupStandardBaseStats(requestedLevel);
	
	scale = 1.0;
	accelerateValue = Ogre::Vector3::ZERO;

//	direction = (Ogre::Math::PI/2);
	cameraVectorFromEntity = Ogre::Vector3(0,150,500);
    
	alive = true;

}//end constructor

Player::~Player()
{
	if(raySceneQuery)
		sceneMgr->destroyQuery(raySceneQuery);

	if(defaultArmsArmour)
		delete defaultArmsArmour;
	if(defaultHeadArmour)
		delete defaultHeadArmour;
	if(defaultBodyArmour)
		delete defaultBodyArmour;
	if(defaultLegsArmour)
		delete defaultLegsArmour;
}

void Player::create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName)
{
	sceneMgr = sentSceneMgr; // get a copy of sceneManager.

	name = theName;

	// Create the entity
	entity = sceneMgr->createEntity(name, "Date Model Unarmed 04.mesh");

	meshBox = entity->getBoundingBox();

		// Create entityNode.
	entityNode = sceneMgr->getRootSceneNode()->createChildSceneNode();

	entityNode->setScale(scale,scale,scale); // make player's mesh smaller.
	entityNode->attachObject(entity); // attach player's entity to player node.
	entity->setVisible(false);

	startingPosition = Ogre::Vector3(0,
		60-meshBox.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*scale,-70);
	entityNode->setPosition(startingPosition); // set position of player node.

	// get length of the mesh in the x axis.
	length = meshBox.getSize().x;

	defaultArmsArmour = new DateArmsArmour;
	defaultArmsArmour->create(sceneMgr, "Yuthla Pads");
	defaultBodyArmour = new DateBodyArmour;
	defaultBodyArmour->create(sceneMgr, "Yuthla Mail");
	defaultHeadArmour = new DateHeadArmour;
	defaultHeadArmour->create(sceneMgr, "Yuthla Helm");
	defaultLegsArmour = new DateLegsArmour;
	defaultLegsArmour->create(sceneMgr, "Yuthla Greaves");
	defaultArmsArmour->entity->setQueryFlags(false);
	defaultHeadArmour->entity->setQueryFlags(false);
	defaultBodyArmour->entity->setQueryFlags(false);
	defaultLegsArmour->entity->setQueryFlags(false);


	playerPosition = startingPosition;
	armsPosition = startingPosition+armsVectorFrombody;
	//equippedWeaponPosition = startingPosition;
	playerOrientation = Ogre::Quaternion::IDENTITY;
	armsOrientation = Ogre::Quaternion::IDENTITY;
	//equippedWeaponOrientation = Ogre::Quaternion::IDENTITY;
	
	entity->setQueryFlags(true);
	// set the camera position same.
	camNode->setPosition(startingPosition+cameraVectorFromEntity);

		// display lined box around mesh.
	entityNode->showBoundingBox(true);

	/*
	// stores starting x direction of player's mesh
	Ogre::Vector3 tempDirection = entityNode->getOrientation() * Ogre::Vector3::UNIT_Z;
	Ogre::Vector3 aPositionInFrontOfStartingCamera(0,0,-500);
	// quat hold information of current direction to target direction.
	Ogre::Quaternion quat = tempDirection.getRotationTo(aPositionInFrontOfStartingCamera);
	entityNode->rotate(quat); // make player's mesh face forward (targetdirection).
	*/

	// create ray query for collision detection.
	raySceneQuery = sceneMgr->createRayQuery(Ogre::Ray());

	//equipArmour(defaultArmsArmour);
	//equipArmour(defaultBodyArmour);
	//equipArmour(defaultHeadArmour);
	//equipArmour(defaultLegsArmour);

	this->armsArmour = defaultArmsArmour;
	this->bodyArmour = defaultBodyArmour;
	this->headArmour = defaultHeadArmour;
	this->legsArmour = defaultLegsArmour;

	arrowCollection.create(sceneMgr);
} // end of create

void Player::update(const Ogre::FrameEvent& evt)
{
	playerPosition = bodyArmour->entityNode->getPosition();
	playerOrientation = bodyArmour->entityNode->getOrientation();
	armsPosition = armsArmour->entityNode->getPosition();
	armsOrientation = armsArmour->entityNode->getOrientation();
//	prePosition = playerPosition;
	//preCamPosition = camNode->getPosition();
	//equippedWeaponPosition = equippedWeapon->entityNode->getPosition();
	//equippedWeaponOrientation = equippedWeapon->entityNode->getOrientation();

	

	//if(!isCollision(playerPosition, Ogre::Vector3::NEGATIVE_UNIT_Y
	//	, "LevelMapEntity")) 
	//{
	//	prePosition = playerPosition;
	//	preCamPosition = camNode->getPosition();
	//	translate(evt);
	//}
	//else
	//{
	//	//reset positions to positions before collision.

	//	bodyArmour->entityNode->setPosition(prePosition);
	//	headArmour->entityNode->setPosition(prePosition);
	//	legsArmour->entityNode->setPosition(prePosition);
	//	armsArmour->entityNode->setPosition(prePosition);
	//	entityNode->setPosition(prePosition);
	//	camNode->setPosition(preCamPosition);
	//}

	if(isJumping)
	{
		jumpTime = jumpTime - 1*evt.timeSinceLastEvent;
		if(jumpTime>0.4)
		{
			//bodyArmour->entityNode->translate(0,600*evt.timeSinceLastEvent,0);
			//headArmour->entityNode->translate(0,600*evt.timeSinceLastEvent,0);
			//legsArmour->entityNode->translate(0,600*evt.timeSinceLastEvent,0);
			//armsArmour->entityNode->translate(0,600*evt.timeSinceLastEvent,0);
			entityNode->translate(0,600*evt.timeSinceLastEvent,0);
			bodyArmour->entityNode->setPosition(entityNode->getPosition());
			headArmour->entityNode->setPosition(entityNode->getPosition());
			legsArmour->entityNode->setPosition(entityNode->getPosition());
			armsArmour->entityNode->setPosition(entityNode->getPosition()+armsVectorFrombody);
			//camNode->translate(0,-300*evt.timeSinceLastEvent,0);
			camNode->setPosition(playerPosition);
	    camNode->translate(cameraVectorFromEntity,Ogre::Node::TS_LOCAL);
			//camNode->setOrientation(entityNode->getOrientation());
			//camNode->setPosition(entityNode->getPosition()+cameraVectorFromEntity);
			//camNode->translate(Ogre::Vector3(0,0,-300));
			//camNode->setOrientation(bodyArmour->entityNode->getOrientation());
		}
		else
		{
			/*bodyArmour->entityNode->translate(0,-300*evt.timeSinceLastEvent,0);
			headArmour->entityNode->translate(0,-300*evt.timeSinceLastEvent,0);
			legsArmour->entityNode->translate(0,-300*evt.timeSinceLastEvent,0);
			armsArmour->entityNode->translate(0,-300*evt.timeSinceLastEvent,0);*/
			entityNode->translate(0,-300*evt.timeSinceLastEvent,0);
			bodyArmour->entityNode->setPosition(entityNode->getPosition());
			headArmour->entityNode->setPosition(entityNode->getPosition());
			legsArmour->entityNode->setPosition(entityNode->getPosition());
			armsArmour->entityNode->setPosition(entityNode->getPosition()+armsVectorFrombody);
			//camNode->translate(0,-300*evt.timeSinceLastEvent,0);
			camNode->setPosition(playerPosition);
	    camNode->translate(cameraVectorFromEntity,Ogre::Node::TS_LOCAL);
			//camNode->setOrientation(entityNode->getOrientation());
			//camNode->setPosition(entityNode->getPosition()+cameraVectorFromEntity);
			//camNode->translate(Ogre::Vector3(0,0,-300));
			//camNode->setOrientation(bodyArmour->entityNode->getOrientation());
		}

		if(jumpTime<0)
		{
			isJumping = false;
			jumpTime = 0.8;
		}
	}
}//end of update

void Player::translate(const Ogre::FrameEvent& evt)
{

	// move the camera node
	if(alive==true)
	{
		//camNode->translate(/*getDirection() **/ accelerateValue * evt.timeSinceLastFrame, 
		//	Ogre::Node::TS_LOCAL);
		camNode->translate(/*getDirection() **/ Ogre::Vector3(accelerateValue.x,accelerateValue.y,accelerateValue.z) * evt.timeSinceLastFrame, 
			Ogre::Node::TS_LOCAL);
		entityNode->translate(/*getDirection() **/ Ogre::Vector3(accelerateValue.x,accelerateValue.y,accelerateValue.z) * evt.timeSinceLastFrame, 
			Ogre::Node::TS_LOCAL);
		bodyArmour->entityNode->setPosition(entityNode->getPosition());
		headArmour->entityNode->setPosition(entityNode->getPosition());
		legsArmour->entityNode->setPosition(entityNode->getPosition());

		//headArmour->entityNode->translate(/*getDirection() **/ Ogre::Vector3(accelerateValue.x,accelerateValue.y,accelerateValue.z) * evt.timeSinceLastFrame, 
		//	Ogre::Node::TS_LOCAL);
		//bodyArmour->entityNode->translate(/*getDirection() **/ Ogre::Vector3(accelerateValue.x,accelerateValue.y,accelerateValue.z) * evt.timeSinceLastFrame, 
		//	Ogre::Node::TS_LOCAL);
		//legsArmour->entityNode->translate(/*getDirection() **/ Ogre::Vector3(accelerateValue.x,accelerateValue.y,accelerateValue.z) * evt.timeSinceLastFrame, 
		//	Ogre::Node::TS_LOCAL);
	}
}//end of translate

//*****************************************************************************
//player Controls
//*****************************************************************************


void Player::takeDamage(int enemyAttackDamage, int enemySpeed)
{
  int damage = 0; // A holder for the overall amount of damage the player takes
  int missChance = 10; // An integer between 0 & 10

  srand(time(NULL));
  // Enemy attack damage comes in
  // Enemy speed comes in

  // Is player fast enough to dodge attack?
  // If so randomize miss chance
  //if (this->realSpeedStt > enemySpeed)
  //{
  //  missChance = rand()%10; 
  //}
  //
  //// If attack didn't miss
  //if (missChance <= 5)
  //{
    damage = enemyAttackDamage - (this->realDefenceStt / 5);
    Ogre::LogManager::getSingleton().logMessage("DAMAGED");
    std::ostringstream buffer;
    buffer << damage;
    Ogre::LogManager::getSingleton().logMessage(buffer.str());
  //}

  // overall damage is effected by player's defence
  // damage = enemyAttackDamage - (realDefenceStat / 5)
  // realHealthStat -= damage
  this->realHealthStt -= damage;

}


void Player::rotate( const OIS::MouseEvent& evt)
{
	// rotateing in the left and right.
	entityNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	headArmour->entityNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	armsArmour->entityNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	legsArmour->entityNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	bodyArmour->entityNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	camNode->yaw(Ogre::Degree(-rotateValue * evt.state.X.rel), Ogre::Node::TS_LOCAL);
	
	camNode->setPosition(playerPosition);
	camNode->translate(cameraVectorFromEntity,Ogre::Node::TS_LOCAL);
}//end of rotate

void Player::updateRealStats()
{
	this->setRealStatsSameAsBaseStats();
	if(bodyEquipped)
	{
		realDefenceStt+=bodyArmour->getDefenceStt();
	}
	if(headEquipped)
	{
		realDefenceStt+=headArmour->getDefenceStt();
	}
	if(armsEquipped)
	{
		realDefenceStt+=armsArmour->getDefenceStt();
	}
	if(legsEquipped)
	{
		realDefenceStt+=legsArmour->getDefenceStt();
	}
	if(this->weaponEquipped)
	{
		realDextStt+=equippedWeapon->getAccuStt();
		realAttackStt+=equippedWeapon->getAttackStt();
	}
}

void Player::reset()
{

	active = true;
	alive = true;
	this->setBaseStatsBasedOnLevel(10);
	this->setRealStatsSameAsBaseStats();

	entityNode->resetOrientation();
	entityNode->setPosition(startingPosition); // set position of player node.

	headArmour->entityNode->resetOrientation();
	headArmour->entityNode->setPosition(startingPosition); // set position of player node.
	armsArmour->entityNode->resetOrientation();
	armsArmour->entityNode->setPosition(startingPosition+armsVectorFrombody);
	bodyArmour->entityNode->resetOrientation();
	bodyArmour->entityNode->setPosition(startingPosition); // set position of player node.
	legsArmour->entityNode->resetOrientation();
	legsArmour->entityNode->setPosition(startingPosition); // set position of player node.

	camNode->resetOrientation();
	// set the camera position same.
	camNode->setPosition(startingPosition+cameraVectorFromEntity);
}

void Player::addGravity(const Ogre::FrameEvent& evt)
{
	if(entityNode)
	{

		
		if(!isCollision(entityNode->getPosition()-Ogre::Vector3(0,displacementFromGround,0),
			entityNode->getOrientation() * Ogre::Vector3(0, -2, 0), "GroundEntity"))
		{
			//prePosition = playerPosition;
			//preCamPosition = camNode->getPosition();
						entityNode->translate(0,-200*evt.timeSinceLastEvent,0);
		bodyArmour->entityNode->translate(0,-200*evt.timeSinceLastEvent,0);
		legsArmour->entityNode->translate(0,-200*evt.timeSinceLastEvent,0);
		armsArmour->entityNode->translate(0,-200*evt.timeSinceLastEvent,0);
		headArmour->entityNode->translate(0,-200*evt.timeSinceLastEvent,0);
		camNode->translate(0,-200*evt.timeSinceLastEvent,0);
		}
		else
		{
			//reset positions to positions before collision.

			bodyArmour->entityNode->setPosition(prePosition);
			headArmour->entityNode->setPosition(prePosition);
			legsArmour->entityNode->setPosition(prePosition);
			armsArmour->entityNode->setPosition(prePosition);
			entityNode->setPosition(prePosition);
			camNode->setPosition(preCamPosition);
		}
	}


}