#include "Pursue_State.h"	
#include "Attack_State.h"
#include "Wander.h"
#include "Flee_State.h"


Pursue_State *Pursue_State::instance = NULL; // to prevent more than one instance
Pursue_State::Pursue_State(){};


Pursue_State *Pursue_State::Get_instance()
{
	if(instance == NULL)
		instance = new Pursue_State;
	return instance;
}//end of Flee_State constructer


void Pursue_State::Enter_State(AIMonster *Monster)
{
	Monster->AIB->WanderOFF();
	Monster->AIB->SeekON();
	Monster->AIB->FleeOFF();
	Monster->AIB->AttackOFF();

	Monster->attackAN = false;
	Monster->idleAN	  = false;
	Monster->walkAN   = true;
}//end of Enter_State()


void Pursue_State::Execute_State(AIMonster *Monster)
{
	Ogre::LogManager::getSingleton().logMessage("\n Pursue execute state\n");
	Monster->mDestination = Monster->Player_Location;
	Monster->AIB->Seek(Monster);
}//end of Execute_State()


void Pursue_State::Exit_State(AIMonster *Monster)
{
	Ogre::Vector3 direction = Monster->Player_Location - Monster->entityNode->getPosition();
	Ogre::Real distance	= direction.normalise();
	
	if(distance <= Monster->length*1.5)
	{
		Change_State(Attack_State::Get_instance(),Monster);
	}//end of if

	if(distance >= 1000)
	{
		Change_State(Wander::Get_instance(),Monster);
	}//end of if

	if(Monster->STARTINGHEALTH <= 10)
	{
		Change_State(Flee_State::Get_instance(),Monster);
	}//end of if
}//end of exit_State()

