#include "Creature.h"
#include <string>
#include "AI_Behaviors.h"
#include "Sprite_Animation.h"
#pragma once

class Snottling: public Creature
{
private:
	//Sprite_Animation *Animation;
	Ogre::Vector3 mPostion;
	AI_Behaviors AIB;
	bool walk;
	bool idle;
	bool attack;

protected:

//	  std::deque<Ogre::Vector3> mWalkList;    // The list of points we are walking to

public:
	Ogre::Real mDistance;                  // The distance the object has left to travel
    Ogre::Vector3 mDirection;              // The direction the object is moving
    Ogre::Vector3 mDestination;            // The destination the object is moving towards
	Ogre::Vector3 prePosition;	

	Snottling()
	{
        mDirection = Ogre::Vector3::ZERO;
		// set the rotation and move speed
		rotateValue = 0.13;
		moveValue = 80;

		alive = true;
		walk  = false;
		attack = false;
		idle = false;

		name = "Snottling";
		scale = 0.25;

//		direction = (Ogre::Math::PI/2);
	}//end of constructor


	~Snottling()
	{
		sceneMgr->destroyQuery(raySceneQuery);
	}//end of destructor


	void setDestination(Ogre::Vector3 GoingTo)
	{
		mDestination = GoingTo;
	}//end of setDestination


	void create(Ogre::SceneManager* sentSceneMgr, Ogre::String theName)
	{
		sceneMgr = sentSceneMgr; // get a copy of sceneManager.
		name = theName;

		// Create the entity
		entity = sceneMgr->createEntity("Ninja", "ninja.mesh");
		Ogre::AxisAlignedBox box = entity->getBoundingBox();
		
		entityNode = sentSceneMgr->getRootSceneNode()->createChildSceneNode();
		entityNode->attachObject(entity); // attach player's entity to player node.
		
		entityNode->setScale(scale,scale,scale); // make player's mesh smaller.
		entityNode->setPosition(150,-box.getCorner(Ogre::AxisAlignedBox::FAR_LEFT_BOTTOM).y*scale,-100); // set position of player node.
		mPostion = entityNode->getPosition();

		length = box.getSize().x;
		entityNode->showBoundingBox(true);
		raySceneQuery = sceneMgr->createRayQuery(Ogre::Ray());
	}//end of create()


	void rotateRobotToDirection(void)
	{
		Ogre::Vector3 src = entityNode->getOrientation() * Ogre::Vector3::UNIT_X;
		src.y = 0;                                                   
		mDirection.y = 0;
		src.normalise();
		Ogre::Real mDistance = mDirection.normalise( );     
		Ogre::Quaternion quat = src.getRotationTo(mDirection);	
		Ogre::Quaternion quat2(Ogre::Degree(-90), Ogre::Vector3::UNIT_X);
		quat * quat2;
		entityNode->rotate(quat);
	}//end of rotateRobotToDirection()


	void update(const Ogre::FrameEvent &evt)
	{
		rotateRobotToDirection();
		//rotate();
		
		if(!isCollision(this->mPostion,Ogre::Vector3(0,0,0)/*getDirection()*/))
		{
			translate(evt);	
			prePosition = this->mPostion;
			
		}//end of if
		else
		{
			walk = false;
			this->mPostion = prePosition;
		}//end of else
		
		//if (!isCollision(get;Position(), getDirection())) 
		//{
		//	prePosition = entityNode->getPosition();
		//	//translate(evt);			
		// }//end of if
		// else
		// {
		// 	entityNode->setPosition(prePosition);
		// }//end of else
		
	}//end of update()


	


	void translate(const Ogre::FrameEvent& evt)
	{
	   walk = true;
		if(alive==true)
		{
			if(walk == true)
			{
				mDirection = mDestination - entityNode->getPosition();
				mDistance  = mDirection.normalise();
				Ogre::Real move = moveValue * evt.timeSinceLastFrame;
				//AIB->Seek(mDestination, entityNode->getPosition(), moveValue, evt);
				//AIB->Seek(mDestination, entityNode->getPosition(), moveValue, evt) -= move;
				mDistance -= move;

				//AIB.Seek(mDestination, entityNode->getPosition(), moveValue, evt)

				if(mDistance > length/1.5)
				{
					Animation(evt,"Walk");
					entityNode->translate(mDirection * move, 
						Ogre::Node::TS_WORLD);
				}//end of if
				else
			    {
				   Animation(evt,"Attack1");
				   //entityNode->setPosition(mDestination);
				}//end of if

			} // of walk if
		}//end of if
	}//end of translate

	void updateRealStats(){}

	void reset()
	{
	}
};//end of class