// Title       : Text File Loader
// Date        : 20/05/13
// Description : Loads .txt files specifically for GUI items

#include "TextFileLoader.h"
#include "OGRE\OgreLogManager.h"

void TextFileLoader::ObjectiveLoader(string &objName, string &objType, bool &objectiveCompleted, string &objDesc)
{ // Loads the Objectives.txt file

  bool fileNotFound = false; // Boolean defines if the file does not exist
  string tempString = "";    // Temp holding string

  // Create the file stream and open the file
  ifstream objectiveFile;   
  objectiveFile.open("objectives.txt");

  if (!objectiveFile)
  { // If the file doesn't exist, file not found
    fileNotFound = true;
  }

  if(!fileNotFound)
  { // If the file exists
    while (objName != ";")
    { // While the string read is not a terminator

      // Read the next string
      objectiveFile >> objName;

      if (objName != ";")
      { // If the string read is not a terminator
        // Add the read string to the temp string
        tempString += objName;
        tempString += " ";
      }
    } // End while

    // Set the objective name and reset the temp string
    objName = tempString;
    tempString = "";

    // Read the type string and save
    objectiveFile >> objType;

    // Read 0 or 1 for objective completed
    objectiveFile >> objectiveCompleted;

    while (objDesc != ";")
    { // Read each string in the objectives description
      objectiveFile >> objDesc;

      if (objDesc != ";")
      { // If the read string isn't a semicolon
        // add string to temp string
        tempString += objDesc;
        tempString += " ";
      }
    }

    // Set the description as the temp string
    objDesc = tempString;

    // Finally, close the file
    objectiveFile.close();
  }
  else
  {
    // If no file exists, log it
    Ogre::LogManager::getSingleton().logMessage("FILE READ: NO FILE");
  }
}